//Speedfind Slider Script v4.2
var showMobile = "false"
var userAgent = userAgentDetect();
var spfdslider = readCookie('spfdslider');
var savedinfo = null;
var userLat = null;
var userLon = null;
var x = null


//Create a new deferred object(waits for Async calls to finish)
var deferred = jQuery.Deferred();
var success = function (position) {
    // resolve the deferred with your object as the data
    deferred.resolve({
        longitude: position.coords.longitude,
        latitude: position.coords.latitude		
    });	
};
var fail = function () {
    // reject the deferred with an error message
    deferred.reject('failed!');
};
/*var getLocation = function () {
	//SET TIMEOUT TO FAIL
	var location_timeout = setTimeout(fail, 12000);
	//GET LOCATION
	navigator.geolocation.getCurrentPosition(success, fail); 
	//RETURN PROMISE
	return deferred.promise(); // return a promise
}
function successCallback(location) {						
	userLat = location.latitude;
	userLon = location.longitude;
	savedinfo = userLat + ',' + userLon;
	//CREATE COOKIE FOR -n- DAYS
	createCookie('spfdslider', savedinfo, 14)
	//SET IFRAME DATA
	if(userAgent == 'web' || userAgent == 'iPad' ){
		var elem = document.getElementById('layoutHolder');
			elem.setAttribute("data","http://speedfind.com/widgets/sliderlayout/"+x +"?userLat=" + userLat +"&userLon=" + userLon);
		//jQuery('#layoutHolder').attr('data','http://speedfind.com/widgets/sliderlayout/'+x +'?userLat=' + userLat +'&userLon=' + userLon);
	}else{
		jQuery('.slide-down-div').attr('src','http://speedfind.com/widgets/sliderlayout/'+x+'?userLat=' + userLat +'&userLon=' + userLon);
	}
};
function failureCallback(errorMessage) {
	//DEFAULT TO GEOLOCATION by Params
	alert("Please enable your browser location service to allow auto-location.");
	if(userAgent == 'web' || userAgent == 'iPad'){
		alert("WEB/Ipad: NO user geocode");
		jQuery('#layoutHolder').attr('data','http://speedfind.com/widgets/sliderlayout/'+x+"?noUserGeoCode=true" );
	}else{
		jQuery('.slide-down-div').attr('src','http://speedfind.com/widgets/sliderlayout/'+x+"?noUserGeoCode=true");
	}
}
*/
function checkForSpfdChromeInstall() {		
	if (document.getElementById('spfd-extension-is-installed')) {
		urlToExt = 'http://speedfind.com/widgets/sliderlayout/' + x;
		var urlNode = document.createElement('div');
		urlNode.id = 'urlToExt';
		urlNode.className += urlNode.ClassName ? urlToExt : urlToExt;
		document.body.appendChild(urlNode);
		return true;
	}
}
function detectIE() {
    var ua = window.navigator.userAgent;
    var msie = ua.indexOf('MSIE');
    var trident = ua.indexOf('Trident/');
    if (msie > 0) {
        // IE 10 or older => return version number
        return parseInt(ua.substring(msie + 5, ua.indexOf('.', msie)), 10);
    }
    if (trident > 0) {
        // IE 11 (or newer) => return version number
        var rv = ua.indexOf('rv:');
        return parseInt(ua.substring(rv + 3, ua.indexOf('.', rv)), 10);
    }
    //Other browser
    return false;
}
/*if(spfdslider){
	//alert("Cookie Found(LAT/LON): "+spfdslider);
	userLat = spfdslider.substr(0, spfdslider.indexOf(","));
	userLon = spfdslider.substr(spfdslider.indexOf(",")+1);	
}*/
jQuery(document).ready(function(){	
	installed = false;
	setTimeout(function(){	
		installed = checkForSpfdChromeInstall();
		if (!installed){
			if(userAgent == 'mobile' && showMobile == "false" || userAgent == 'android' && showMobile == "false"){
				//IF USERAGENT is MOBILE & IF PLUGIN SETTING IS CHECKED TO DISABLE MOBILE DONT CONT. TO BUILD
				return
			}
			buildIt();
			tabSettings();
			//ON REFRESH LOCATION CLICK
			jQuery('#refreshlocation').click(function(e) {
				
				//UPDATE LOCATION
				getLocation().then(
					function (location) {
						// success, location is the object you passed to resolve
						successCallback(location);
					}, 
					function (errorMessage) {
						// fail, errorMessage is the string you passed to reject
						failureCallback(errorMessage);							
					}
				);
			});			
			if(detectIE()){
				jQuery('.slide-down-div').css('top','-38px');
			}
			if(userAgent == 'mobile'){ 
				jQuery("#speedfind-marker").click(function(event) {
					jQuery('.speedfindShowImg').toggle();		
					var slidediv = jQuery('.slide-down-div')
					if(slidediv.hasClass('closed')){
						slideDownMobile();
						jQuery('#speedfind-container').css("margin-bottom", "562px");
						if(detectIE()){
							jQuery('.slide-down-div').css('top','0px');
						}
						//ASK FOR LOCATION NOW IF ATTR is EMPTY
						var testthisfirst = $('.slide-down-div').attr('src');
						if(testthisfirst == 'http://speedfind.com/loading/'){
							getLocation().then(
								function (location) {
									// success, location is the object you passed to resolve
									successCallback(location);
								}, 
								function (errorMessage) {
									// fail, errorMessage is the string you passed to reject
									failureCallback(errorMessage);
								}															
							);
							
						}
					}
					else {
						slideUpMobile();
						jQuery('#speedfind-container').css("margin-bottom", "0px");
						if(detectIE()){
							jQuery('.slide-down-div').css('top','-38px');
						}					
					}
				});
			}
			else if(userAgent == 'android'){
				jQuery("#speedfind-marker").click(function(event) {			
					window.open("http://speedfind.com/"+x, '_blank');
				});
			}
			else if(userAgent == 'web' || userAgent == 'iPad'){
				//WEB SLIDER HANDLE
				jQuery('.handle').click(function(e) {
					var slidediv = jQuery('.slide-out-div-4')				
					if(slidediv.hasClass('open')){
						slideIn();
						jQuery('#sfHolder').attr('src','');
						jQuery("#sfHolder").hide();
					}
					else {
						slideOut();
						var testthisfirst = jQuery('#layoutHolder').attr('data');
						if(testthisfirst == 'http://speedfind.com/loading/'){
							getLocation().then(
								function (location) {
									// success, location is the object you passed to resolve
									successCallback(location);
								}, 
								function (errorMessage) {
									// fail, errorMessage is the string you passed to reject
									failureCallback(errorMessage);
								}															
							);						
						}
						else{
							//TO DO...
						}
						jQuery('#sfHolder').attr('src','http://speedfind.com/sliderView?'+ x);			
						jQuery("#sfHolder").show();
					}
					//HIDE IF ELEMENT IS CLICKED OUTSIDE
					jQuery(document).mouseup(function (e){
						var container = jQuery('.slide-out-div-4');
						if (!container.is(e.target) && container.has(e.target).length === 0 && container.hasClass('open')) {
							slideIn();
							jQuery('#sfHolder').attr('src','');
							jQuery("#sfHolder").hide();
						}
					});
				});
			}			
		}
	},500);
});

function userAgentDetect(){	
	if((navigator.userAgent.match(/(iPhone|iPod|BlackBerry|webOS|Windows CE|IEMobile|Opera Mini|Opera Mobi|HTC|LG-|LGE|SAMSUNG|Samsung|SEC-SGH|Symbian|Nokia|PlayStation|PLAYSTATION|Nintendo DSi)/i))){
		userAgent ='mobile';
			}
	else if ((navigator.userAgent.match(/(iPad)/i))){
		userAgent ='mobile';
	}
	else if ((navigator.userAgent.match(/(Android.*Mobile)/i))){
		userAgent ='android';
	}
	else {
		userAgent ='web';
	}
	return userAgent
}

function tabSettings(){
	if (userAgent == 'web'){
		jQuery(function(){
			jQuery('.slide-out-div-4').tabSlideOut({
	            tabHandle: '.handle',                     
	            pathToTabImage: 'https://geoto.s3.amazonaws.com/images/images/Speedfind/Speedfind-tab-83.png', 
	            imageHeight: '153px',                     
	            imageWidth: '41px',                      
	            tabLocation: 'left',                   
	            speed: 500,                             
	            action: 'click',                        
	            topPos: '100px',                         
	            leftPos: '20px',                        
	            fixedPosition: true,                     
				onLoadSlideOut: false
			});
		});	
	}
	else if (userAgent == 'iPad'){
		jQuery(function(){
			jQuery('.slide-out-div-4').tabSlideOut({
	            tabHandle: '.handle',                     
	            pathToTabImage: 'https://geoto.s3.amazonaws.com/images/images/Speedfind/Speedfind-tab-83.png', 
	            imageHeight: '153px',                     
	            imageWidth: '41px',                      
	            tabLocation: 'left',                   
	            speed: 500,                             
	            action: 'click',                        
	            topPos: '60px',                         
	            leftPos: '20px',                        
	            fixedPosition: true,                     
				onLoadSlideOut: false
			});
		});	
	}
	else if (userAgent =='mobile' || userAgent == 'android'){
		jQuery('*').filter(function(){ 
		return jQuery(this).css('position').toLowerCase().indexOf('fixed') > -1 
	}).addClass('weAreFixed');
	
	jQuery('.weAreFixed').filter(function() {
		return jQuery(this).css('top').toLowerCase().indexOf('0px') > -1;
	}).addClass('topDawgElement');
	
	jQuery('.speedfind-container').removeClass('topDawgElement');
	jQuery('.topDawgElement').css('top','41px');
	
	$('.slide-down-div').css('top','-51px');
		jQuery('body').css("margin-top","41px");
		jQuery(function(){	
			jQuery('.slide-out-div-4').tabSlideOut({	
	        	tabHandle: '.handle',                     
	            pathToTabImage: 'https://geoto.s3.amazonaws.com/images/images/Speedfind/Speedfind-Logo-41.jpg', 
	            imageHeight: '41px',                     
	            imageWidth: '153px',                      
	            tabLocation: 'mobile',                   
	            speed: 500,
	            addtOffset: 5,
	            action: 'click',                        
	            topPos: '100px',                         
	            leftPos: '0px',                        
	            fixedPosition: true,                     
				onLoadSlideOut: false
			});
		});
	}
};

function buildIt(){	
	var script = document.getElementById('speedfind-slider-install-script');
	var queryString = script.src.replace(/^[^\?]+\??/,'');
	x = queryString;
	if (userAgent =='web'){
		//Build the widget framework
		//Note: The iframe src is generated through the geoto-slider-builder.js with params( ex: "geoto-slider-builder.js?rubys" )	
		jQuery('body').append("<div class='slide-out-div slide-out-div-4' style='min-height:603px; border: 1px solid #585858; z-index: 10000; background-color: #38393E;'>" +
        "<a class='handle' title='Speedfind a Location' >Content</a>" +
        "<object id='layoutHolder' type='text/html' data='https://speedfind.com/widgets/sliderlayout/" + x + "' width='340px' height='580px' style='border:none; margin:10px;'></object>" +
		"<iframe id='sfHolder' type='text/html' src='' width='1px' frameBorder='0' height='1px' style='display:none;'></iframe>" +
        "</div>");
	}
	else if (userAgent =='iPad'){
		//Build the widget framework
		//Note: The iframe src is generated through the geoto-slider-builder.js with params( ex: "geoto-slider-builder.js?rubys" )	
		jQuery('body').append("<div class='slide-out-div slide-out-div-4' style='min-height:560px; border: 1px solid #585858; z-index: 100; background-color: #38393E;'><a id='refreshlocation' href='#' style='display: inherit; text-align: center; margin-bottom: -6px; margin-top: 2px; color:#FFFFFF;'>Refresh Location</a>" +
        "<a class='handle' title='Speedfind a Location' >Content</a>" +
        "<object id='layoutHolder' type='text/html' data='https://speedfind.com/widgets/sliderlayout/" + x + "' width='340px' height='526px' style='border:none; margin:10px;'></object>" +
		"<iframe id='sfHolder' type='text/html' src='' width='1px' frameBorder='0' height='1px' style='display:none;'></iframe>" +
        "</div>");
	}
	else if (userAgent =='mobile'){
			jQuery('body').css("margin-top","41px");
			jQuery('body').css("position","relative");
			jQuery('body').prepend("<div id='speedfind-container' class='speedfind-container' style='left:0;position: fixed; top: 0px;z-index: 99999;width:100%;'><div id='speedfind-marker' style='cursor:pointer;height: 38px;width: 100%;text-align: center;;background: #E0E0E0;background: -moz-linear-gradient(top,#353A40 0,#353A40 100%);background: -webkit-gradient(linear,left top,left bottom,color-stop(0%,#353A40),color-stop(100%,#353A40));background: -webkit-linear-gradient(top,#353A40 0,#353A40 100%);background: -o-linear-gradient(top,#353A40 0,#353A40 100%);background: -ms-linear-gradient(top,#353A40 0,#353A40 100%);background: linear-gradient(to bottom,#353A40 0,#353A40 100%);'><div id='slider-content' style='display: inline-block;'><img class='speedfindIcon speedfindShowImg' src='https://geoto.s3.amazonaws.com/images/logos/Speedfind_logo_expand.jpg' style='height: 35px;'/><img class='speedfindIcon speedfindShowImg' src='https://geoto.s3.amazonaws.com/images/logos/Speedfind_logo_collapse.jpg' style='display:none;height: 35px;'/><iframe class='slide-down-div closed' src='http://speedfind.com/widgets/sliderlayout" + x + "' width='100%' height='514px' style='margin-top:-1000px; border:none;position:relative;'></iframe></div></div></div>");
	}
	else if( userAgent == 'android'){
			jQuery('body').css("margin-top","41px");
			jQuery('body').css("position","relative");
			jQuery('body').prepend("<div id='speedfind-container' class='speedfind-container' style='left:0;position: fixed; top: 0px;z-index: 99999;width:100%;'><div id='speedfind-marker' style='cursor:pointer;height: 35px;width: 100%;text-align: center;;background: #E0E0E0;background: -moz-linear-gradient(top,#353A40 0,#353A40 100%);background: -webkit-gradient(linear,left top,left bottom,color-stop(0%,#353A40),color-stop(100%,#353A40));background: -webkit-linear-gradient(top,#353A40 0,#353A40 100%);background: -o-linear-gradient(top,#353A40 0,#353A40 100%);background: -ms-linear-gradient(top,#353A40 0,#353A40 100%);background: linear-gradient(to bottom,#353A40 0,#353A40 100%);'><div id='slider-content' style='display: inline-block;'><img class='speedfindIcon speedfindShowImg' src='https://geoto.s3.amazonaws.com/images/logos/Speedfind_logo_expand.jpg' style='height: 35px;'/><img class='speedfindIcon speedfindShowImg' src='https://geoto.s3.amazonaws.com/images/logos/Speedfind_logo_collapse.jpg' style='display:none;height: 35px;'/></div></div></div>");
	}	
	/*IF WE HAVE COOKIE DO THIS 
	if(userLat != null && userLon != null){
		//WEB
		jQuery('#layoutHolder').attr('data','http://speedfind.com/widgets/sliderlayout/'+x +'?userLat=' + userLat +'&userLon=' + userLon);
	}
	else{
		//TO DO FOR MOBILE
	}
	*/
	if (userAgent =='mobile'){
		var mobileHeight = jQuery(window).height()		
		var adjustheight = mobileHeight - 51
		//if (mobileHeight < 514){
    		jQuery('.slide-down-div').css({'height' : adjustheight + 'px'});
		//}
	}

(function($){
	    $.fn.tabSlideOut = function(callerSettings) {
	        var settings = $.extend({
	            tabHandle: '.handle',
	            speed: 300, 
	            action: 'click',
	            tabLocation: 'left',
	            topPos: '100px',
	            leftPos: '20px',
				borderColor: '#585858',
				addtOffset: 58,
	            fixedPosition: false,
	            positioning: 'absolute',
	            pathToTabImage: null,
	            imageHeight: null,
	            imageWidth: null,
	            onLoadSlideOut: false                       
	        }, callerSettings||{});

	        settings.tabHandle = $(settings.tabHandle);
	        var obj = this;
	        if (settings.fixedPosition === true) {
	            settings.positioning = 'fixed';
	        } else {
	            settings.positioning = 'absolute';
	        }

	        if (document.all && !window.opera && !window.XMLHttpRequest) {
	            settings.positioning = 'absolute';
	        }

	        
	        if (settings.pathToTabImage != null) {
	            settings.tabHandle.css({
	            'background' : 'url('+settings.pathToTabImage+') no-repeat',
	            'width' : settings.imageWidth,
	            'height': settings.imageHeight,
				'border': '1px solid' + settings.borderColor,
				'border-left': 'none',
	            'right' : 0 + 'px'
	            });
	        }
	        
	        settings.tabHandle.css({ 
	            'display': 'block',
	            'textIndent' : '-99999px',
	            'outline' : 'none',
	            'position' : 'absolute'
	        });
	        
	        obj.css({
	            'line-height' : '1',
	            'position' : settings.positioning
	            
	        });
			var properties = {
	            containerWidth: parseInt(obj.outerWidth(), 10) + 'px',
				containerWidthWithShadow: parseInt((obj.outerWidth() + settings.addtOffset), 10) + 'px',
	            containerHeight: parseInt(obj.outerHeight(), 10) + 'px',
	            containerHeightInt: parseInt(obj.outerHeight(), 10),
	            tabWidth: parseInt(settings.tabHandle.outerWidth(), 10) + 'px',
	            tabHeight: parseInt(settings.tabHandle.outerHeight(), 10) + 'px'
	        };
			if(userAgent == 'web'|| userAgent =='iPad') {
	            obj.css({
	                'height' : properties.containerHeight,
	                'top' : settings.topPos,
					'left': '-361px'
	            });	            
	            settings.tabHandle.css({'top' : '177px','right' : '-' + properties.tabWidth});
	        }	        	        	        
	        settings.tabHandle.click(function(e){
	            e.preventDefault();
	        });	        
	        slideUpMobile = function() {
	        	$('.slide-down-div').animate({ marginTop: '-1000px'}, 300).addClass('closed');
				$('.slide-down-div').css('top','-55px');
	        	$('body').css({ position: 'relative', marginTop: 41 + 'px' })
	        }
	        slideDownMobile = function() {
	        	$('.slide-down-div').animate({ marginTop: '50px'}, 300).removeClass('closed');
				$('.slide-down-div').css('top','-51px');
	        	$('body').css({ position: 'relative', marginTop: $(window).height() + 'px' })
	        };
	        slideIn = function() {	        	
	            if (userAgent == 'web' || userAgent =='iPad') {
	                obj.animate({left: '-361px' }, settings.speed, 'easeInOutBack').removeClass('open');
	            } 
				else if (userAgent == 'mobile') {
	            	$('body').removeClass('fixed');	            	
	            	var screenHeight = $(window).height();
	                var animateHeightTest = properties.containerHeightInt - screenHeight
	                var animateHeight = 0
	                var adjustHeight = properties.containerHeightInt + 20 + 'px'
	                if (animateHeightTest >=0) {
	                	animateHeight = '-' + animateHeightTest
	                }
	                else {
	                	animateHeight = animateHeightTest
	                }                
	                    obj.animate({bottom: '-' + adjustHeight}, settings.speed).removeClass('open');
	                    obj.css({'position' : 'fixed','marginTop' : '0px' });
	            }
	            obj.css({'position' : 'fixed','marginTop' : '0px' });	            	            
	        };
	        
	        slideOut = function() {
	            if (userAgent == 'web' || userAgent =='iPad') {
	                obj.animate({left:'0px'},  settings.speed, 'easeInOutBack').addClass('open');
	            } else if (userAgent == 'mobile') {
	            	$('body').addClass('fixed');
	            	var screenHeight = $(window).height();
	                var animateHeightTest = properties.containerHeightInt - screenHeight
	                var animateHeight = 0
	                if (animateHeightTest >=0) {
	                	animateHeight = '-' + screenHeight - 30
	                }
	                else {
	                	animateHeight = animateHeightTest - 30
	                }
	            	obj.animate({bottom: animateHeight},  settings.speed).addClass('open');
	            }
	        };													
	    }; 	    
	})(jQuery);
}
function createCookie(name, value, days) {
    var expires;
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        expires = "; expires=" + date.toGMTString();
    } else {
        expires = "";
    }
    document.cookie = escape(name) + "=" + escape(value) + expires + "; path=/";
}
function readCookie(name) {
    var nameEQ = escape(name) + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) === ' ') c = c.substring(1, c.length);
        if (c.indexOf(nameEQ) === 0) return unescape(c.substring(nameEQ.length, c.length));
    }
    return null;
}
jQuery.extend( jQuery.easing,{
	easeInOutBack: function (x, t, b, c, d, s) {
		if (s == undefined) s = 1.70158; 
		if ((t/=d/2) < 1) return c/2*(t*t*(((s*=(1.525))+1)*t - s)) + b;
		return c/2*((t-=2)*t*(((s*=(1.525))+1)*t + s) + 2) + b;
	}
});